// MonoGame - Copyright (C) The MonoGame Team
// This file is subject to the terms and conditions defined in
// file 'LICENSE.txt', which is part of this source code package.

namespace Microsoft.Xna.Framework.Graphics
{
    /// <summary>
    /// Defines the faces in a cube map for the <see cref="TextureCube"/> class.
    /// </summary>
	public enum CubeMapFace
    {
        /// <summary>
        /// Positive X face in the cube map.
        /// </summary>
		PositiveX,
        /// <summary>
        /// Negative X face in the cube map.
        /// </summary>
        NegativeX, 
        /// <summary>
        /// Positive Y face in the cube map.
        /// </summary>
        PositiveY,
        /// <summary>
        /// Negative Y face in the cube map.
        /// </summary>
        NegativeY,
        /// <summary>
        /// Positive Z face in the cube map.
        /// </summary>
        PositiveZ,
        /// <summary>
        /// Negative Z face in the cube map.
        /// </summary>
		NegativeZ
	}
}

